#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

//PD0  e cu problema 
int pini_D[4] = {PD4, PD5, PD0, PD1};

int count;


//ISR(PCINT30_vect) {

	/* daca butonul este apasat */
//	if ((PIND & (1 << PD6)) == 0)
//		count++;
//}


// Aprindere si stingerea led-urilor pe nivele 
void levels() {

	int i, j;

	for(i = 0; i < 4; i++) {
		
		//Se aprinde fiecare nivel
		if (i != 2) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << pini_D[2]);
		}
		else
			PORTD |= (1 << pini_D[i]);
		
		//Se aprind becurile
		for (j = 0; j < 8; j++) {
			
			PORTA |= (1 << j);
			PORTC |= (1 << j);
		}
		
		_delay_ms(10000);
		PORTD &= ~(1 << pini_D[i]);
	}
	
	_delay_ms(10000);
	
	// Stingere led-uri
	for(i = 0; i < 8; i++) {
	
		PORTC &= ~(1 << i);
		PORTA &= ~(1 << i);
	}

}

// Aprindere + stingere sarpe
void snake () {

	int i, j;

	for(i = 0; i < 4; i++) {
		
		//Se aprinde fiecare nivel
		if (i != 2) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << PD0);
		}
		else
			PORTD |= (1 << pini_D[i]);
		
		//Se aprind becurile consecutiv,
		//coloana dupa coloana
		for (j = 0; j < 4; j++) {
			
			PORTA |= (1 << j);
			_delay_ms(2000);
		}
		
		for (j = 7; j >= 4; j--) {
			
			PORTA |= (1 << j);
			_delay_ms(2000);
		}
		
		for (j = 7; j >= 4; j--) {
			
			PORTC |= (1 << j);
			_delay_ms(2000);
		}
		
		for (j = 0; j < 4; j++) {
			
			PORTC |= (1 << j);
			_delay_ms(2000);
		}
		
		//Se sting becurile consecutiv,
		//coloana dupa coloana
		for (j = 3; j >= 0; j--) {
			
			PORTC &= ~(1 << j);
			_delay_ms(2000);
		}
		
		for (j = 4; j <= 7; j++) {
			
			PORTC &= ~(1 << j);
			_delay_ms(2000);
		}
		
		for (j = 4; j <= 7; j++) {
			
			PORTA &= ~(1 << j);
			_delay_ms(2000);
		}
		
		for (j = 3; j >= 0; j--) {
			
			PORTA &= ~(1 << j);
			_delay_ms(2000);
		}
			
		//Se sting nivelele	
		_delay_ms(10000);
		PORTD &= ~(1 << pini_D[i]);
	}
	
	_delay_ms(10000);

}


// Aprindere pe coloane, pe nivele 
void columns_levels() {

	int i, j;
	
	for(i = 0; i < 4; i++) {
		
		if (i != 2 && i != 3) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << PD0);
		}
		else
			PORTD |= (1 << pini_D[i]);
			
		// Prima coloana
		for (j = 0; j < 4; j++) {			
			
			PORTA |= (1 << j);
		}
		
		_delay_ms(10000);
	}
	
	for( i = 0; i < 4; i++) { 
		
		PORTD &= ~(1 << pini_D[i]);
		PORTA &= ~(1 << i);
	}
	
	
	for(i = 3; i >= 0; i--) {
		
		if (i == 3) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << PD0);
		}
		else
			PORTD |= (1 << pini_D[i]);
			
		// A doua coloana
		for (j = 7; j >= 4; j--)
			PORTA |= (1 << j);
			
		_delay_ms(10000);
	}
	
	for( i = 0; i < 4; i++)
		PORTD &= ~(1 << pini_D[i]);
	for (j = 7; j >= 4; j--)
		PORTA &= ~(1 << j);
	
	
	for(i = 0; i < 4; i++) {
		
		if (i != 2 && 1 != 3) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << PD0);
		}
		else
			PORTD |= (1 << pini_D[i]);
			
		// A treia coloana
		for (j = 7; j >= 4; j--)			
			PORTC |= (1 << j);
			
		_delay_ms(10000);
	}
	
	for( i = 0; i < 4; i++)
		PORTD &= ~(1 << pini_D[i]);
	for (j = 7; j >= 4; j--)			
		PORTC &= ~(1 << j);
	
	for(i = 3; i >= 0; i--) {
		
		if (i == 3) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << PD0);
		}
		else
			PORTD |= (1 << pini_D[i]);
			
		// A patra coloana
		for (j = 0; j < 4; j++) 
			PORTC |= (1 << j);
			
		_delay_ms(10000);
	}
	
	for( i = 0; i < 4; i++) {
		PORTD &= ~(1 << pini_D[i]);
		PORTC &= ~(1 << i);
	}

}

// Se aprinde treptat paralelipipede 
//	din ce in ce mai mari 
void crescendo() {

	int i, j;

	PORTD |= (1 << PD4);
	PORTD &= ~(1 << PD0);
	
	for(i = 0; i < 4; i++) 
		PORTA |= (1 << i);
	
	
	_delay_ms(20000);
	
	PORTD |= (1 << PD5);
	PORTD &= ~(1 << PD0);
	
	for(i = 4; i < 8; i++) 
		PORTA |= (1 << i);
	
	
	_delay_ms(20000);
	
	PORTD |= (1 << PD0);
	
	for(i = 4; i < 8; i++)
		PORTC |= (1 << i);
	
	
	_delay_ms(20000);
	
	PORTD |= (1 << PD1);
	
	for(i = 0; i < 4; i++)
		PORTC |= (1 << i);
	
	
	//Stingere
	for(i = 0; i < 4; i++) 	
		PORTC &= ~(1 << i);
	
	PORTD &= ~(1 << PD1);

	_delay_ms(20000);
	
	for(i = 4; i < 8; i++)
		PORTC &= ~(1 << i);
	
	PORTD &= ~(1 << PD0);
	
	_delay_ms(20000);
	
	for(i = 4; i < 8; i++)
		PORTA &= ~(1 << i);
	
	PORTD &= ~(1 << PD5);
	
	_delay_ms(20000);
	
	for(i = 0; i < 4; i++)	
		PORTA &= ~(1 << i);

	PORTD &= ~(1 << PD4);
	
	_delay_ms(20000);

}

//Aprindere in spirala pe nivele
void spiral() {

	int i, j;

	for(i = 0; i < 4; i++) {
		
		if (i != 2) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << PD0);
		}
		else
			PORTD |= (1 << pini_D[i]);
			
		for (j = 0; j < 4; j++) {
			
			PORTA |= (1 << j);
			_delay_ms(2000);
		}
		
		PORTA |= (1 << PA7);
		_delay_ms(2000);
		
		PORTC |= (1 << PC4);
		_delay_ms(2000);
	
		
		for (j = 0; j < 4; j++) {
			
			PORTC |= (1 << j);
			_delay_ms(2000);
		}
		
		PORTC |= (1 << PC7);
		_delay_ms(2000);
		
		PORTA |= (1 << PA4);
		_delay_ms(2000);
		
		PORTA |= (1 << PA5);
		_delay_ms(2000);
		
		PORTA |= (1 << PA6);
		_delay_ms(2000);
		
		PORTC |= (1 << PC6);
		_delay_ms(2000);
		
		PORTC |= (1 << PC5);
		_delay_ms(2000);
		
		
		
		PORTC &= ~(1 << PC5);
		_delay_ms(2000);
		
		PORTC &= ~(1 << PC6);
		_delay_ms(2000);
		
		PORTA &= ~(1 << PA6);
		_delay_ms(2000);
		
		PORTA &= ~(1 << PA5);
		_delay_ms(2000);
		
		PORTA &= ~(1 << PA4);
		_delay_ms(2000);
		
		PORTC &= ~(1 << PC7);
		_delay_ms(2000);
		
		for (j = 3; j >= 0; j--) {
			
			PORTC &= ~(1 << j);
			_delay_ms(2000);
		}
		
		PORTC &= ~(1 << PC4);
		_delay_ms(2000);
		
		PORTA &= ~(1 << PA7);
		_delay_ms(2000);
		
		for (j = 3; j >= 0; j--) {
			
			PORTA &= ~(1 << j);
			_delay_ms(2000);
		}
				
		_delay_ms(10000);
		PORTD &= ~(1 << (4 + i));
	}
	
	for (i = 0; i < 4; i++) 
		PORTD |= (1 << pini_D[i]);
	
	PORTA |= (1 << PA7);
	_delay_ms(2000);
	
	PORTC |= (1 << PC4);
	_delay_ms(2000);

	
	for (j = 0; j < 4; j++) {
		
		PORTC |= (1 << j);
		_delay_ms(2000);
	}
	
	PORTC |= (1 << PC7);
	_delay_ms(2000);
	
	PORTA |= (1 << PA4);
	_delay_ms(2000);
	
	PORTA |= (1 << PA5);
	_delay_ms(2000);
	
	PORTA |= (1 << PA6);
	_delay_ms(2000);
	
	PORTC |= (1 << PC6);
	_delay_ms(2000);
	
	PORTC |= (1 << PC5);
	_delay_ms(2000);
	
	
	PORTC &= ~(1 << PC5);
	_delay_ms(2000);
	
	PORTC &= ~(1 << PC6);
	_delay_ms(2000);
	
	PORTA &= ~(1 << PA6);
	_delay_ms(2000);
	
	PORTA &= ~(1 << PA5);
	_delay_ms(2000);
	
	PORTA &= ~(1 << PA4);
	_delay_ms(2000);
	
	PORTC &= ~(1 << PC7);
	_delay_ms(2000);
	
	for (j = 3; j >= 0; j--) {
		
		PORTC &= ~(1 << j);
		_delay_ms(2000);
	}
	
	PORTC &= ~(1 << PC4);
	_delay_ms(2000);
	
	PORTA &= ~(1 << PA7);
	_delay_ms(2000);
	
	for (j = 3; j >= 0; j--) {
		
		PORTA &= ~(1 << j);
		_delay_ms(2000);
	}
	
	for(i = 0; i < 4; i++)
		PORTD &= ~(1 << pini_D[i]);

}

// Jos - Sus / Sus - Jos
void tower_up_and_down() {

	int i, j;
	
	//Sting toate nivelele
	for(i = 0; i < 4; i++)
		PORTD &= ~(1 << pini_D[i]);
	
	//Aprind toate becurile de pe inelul exterior
	for (j = 0; j < 4; j++)	
		PORTA |= (1 << j);
			
	PORTA |= (1 << PA7);
	PORTC |= (1 << PC4);
	
	for (j = 0; j < 4; j++)		
		PORTC |= (1 << j);
	
	PORTC |= (1 << PC7);
	PORTA |= (1 << PA4);
	
	//Aprind fiecare nivel
	for(i = 0; i < 4; i++) {
		
		if (i != 2) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << PD0);
		}
		else
			PORTD |= (1 << pini_D[i]);
			
		_delay_ms(5000);
		
		PORTD &= ~(1 << pini_D[i]);
	}
	
	//Sting becurile
	for (j = 0; j < 4; j++)	
		PORTA &= ~(1 << j);
			
	PORTA &= ~(1 << PA7);
	PORTC &= ~(1 << PC4);
	
	for (j = 0; j < 4; j++)		
		PORTC &= ~(1 << j);
	
	PORTC &= ~(1 << PC7);
	PORTA &= ~(1 << PA4);
	
	
	//Aprind becurile din inelul interior
	PORTA |= (1 << PA5);
	PORTC |= (1 << PC6);
	PORTC |= (1 << PC5);
	PORTA |= (1 << PA6);
	
	//Aprind fiecare nivel
	for(i = 3; i >= 0; i--) {
		
		if (i != 2) {	
			
			PORTD |= (1 << pini_D[i]);
			PORTD &= ~(1 << PD0);
		}
		else
			PORTD |= (1 << pini_D[i]);
			
		_delay_ms(5000);
		
		PORTD &= ~(1 << pini_D[i]);
	}
	
	//Sting becurile
	PORTA &= ~(1 << PA5);
	PORTC &= ~(1 << PC6);
	PORTC &= ~(1 << PC5);
	PORTA &= ~(1 << PA6);

}

//Se aprind cubulete
void little_cubes() {

	PORTD |= (1 << PD4);
	PORTD |= (1 << PD5);
	PORTD &= ~(1 << PD0);
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	
	_delay_ms(10000);
	
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD1);
	
	_delay_ms(10000);
	
	PORTD &= ~(1 << PD4);
	PORTD &= ~(1 << PD5);
	PORTD &= ~(1 << PD0);
	PORTD &= ~(1 << PD1);
	
	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);
	PORTA &= ~(1 << PA4);
	PORTA &= ~(1 << PA5);
	
	_delay_ms(10000);
	
	
	PORTD |= (1 << PD4);
	PORTD |= (1 << PD5);
	PORTD &= ~(1 << PD0);
	
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	_delay_ms(10000);
	
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD1);
	
	_delay_ms(10000);
	
	PORTD &= ~(1 << PD4);
	PORTD &= ~(1 << PD5);
	PORTD &= ~(1 << PD0);
	PORTD &= ~(1 << PD1);
	
	PORTA &= ~(1 << PA2);
	PORTA &= ~(1 << PA3);
	PORTA &= ~(1 << PA6);
	PORTA &= ~(1 << PA7);

	_delay_ms(10000);
	
	
	
	PORTD |= (1 << PD4);
	PORTD |= (1 << PD5);
	PORTD &= ~(1 << PD0);
	
	PORTC |= (1 << PC5);
	PORTC |= (1 << PC4);
	PORTC |= (1 << PC1);
	PORTC |= (1 << PC0);
	
	_delay_ms(10000);
	
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD1);
	
	_delay_ms(10000);
	
	PORTD &= ~(1 << PD4);
	PORTD &= ~(1 << PD5);
	PORTD &= ~(1 << PD0);
	PORTD &= ~(1 << PD1);

	PORTC &= ~(1 << PC5);
	PORTC &= ~(1 << PC4);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC0);
	
	_delay_ms(10000);
	
	
	
	PORTD |= (1 << PD4);
	PORTD |= (1 << PD5);
	PORTD &= ~(1 << PD0);
	
	PORTC |= (1 << PC2);
	PORTC |= (1 << PC3);
	PORTC |= (1 << PC6);
	PORTC |= (1 << PC7);
	
	_delay_ms(10000);
	
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD1);
	
	_delay_ms(10000);
	
	PORTD &= ~(1 << PD4);
	PORTD &= ~(1 << PD5);
	PORTD &= ~(1 << PD0);
	PORTD &= ~(1 << PD1);

	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);
	PORTC &= ~(1 << PC6);
	PORTC &= ~(1 << PC7);

}


int main() 
{

	/* Se seteaza pinii de iesire */
    DDRA = 0xFF;
    DDRC = 0xFF;
    DDRD = 0xFF;
	
	/* activez rezistenta de pull-up pentru pinul PD6 - buton */
	PORTD |= (1 << PD6);
	
	/* activez intreruperea pe PCINT30 : bitul 7 de pe PCMSK3 */
	//PCICR |= (1 << PCIE3);
	//PCMSK3 |= (1 << PCINT30);
	//sei();
	
	
	while(1) {	
	
		/*	
		count++;

		switch ( count ) {
			
			case 1:
			  levels();
			  break;
			
			case 2:
			  snake();
			  break;
			
			case 3:
			  columns_levels();
			  break;
			
			case 4:
			  crescendo();
			  break;
			
			case 5:
			  spiral();
			  break;
			  
			case 6:
			  tower_up_and_down();
			  break;
			  
			case 7:
			  little_cubes();
			  count = 0;
			  break;
			
			default:
			  break;
		}
		*/

		levels();
		snake ();
		columns_levels();
		crescendo();
		spiral();
		tower_up_and_down();
		little_cubes();
	
	}
	
	

}
